#!/bin/bash
echo "Running inference tests..."

testnum=0

echo "Testing Max-Product..."

# Testing BP on simple chain network

testnum=$(($testnum+1))
../../bin/maxprod -m test1.bif -log out1-bn.log
diff -b -q out1-bn.log test1.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum BN: FAILED"; else echo "Test $testnum BN: Success"; fi

../../bin/maxprod -m test1.mn -log out1-mn.log
diff -b -q out1-mn.log test1.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN: FAILED"; else echo "Test $testnum MN: Success"; fi

../../bin/maxprod -m test1-f.mn -log out1-mnf.log
diff -b -q out1-mnf.log test1.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN-F: FAILED"; else echo "Test $testnum MN-F: Success"; fi

../../bin/acquery -mpe -c test1.ac -log out1-ac.log
diff -b -q out1-ac.log test1.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum AC: FAILED"; else echo "Test $testnum AC: Success"; fi

testnum=$(($testnum+1))
../../bin/maxprod -m test1.bif -ev test1.ev -log out2-bn.log
diff -b -q out2-bn.log test2.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum BN: FAILED"; else echo "Test $testnum BN: Success"; fi

../../bin/maxprod -m test1.mn -ev test1.ev -log out2-mn.log
diff -b -q out2-mn.log test2.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN: FAILED"; else echo "Test $testnum MN: Success"; fi

../../bin/maxprod -m test1-f.mn -ev test1.ev -log out2-mnf.log
diff -b -q out2-mnf.log test2.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN-F: FAILED"; else echo "Test $testnum MN-F: Success"; fi

../../bin/acquery -mpe -c test1.ac -ev test1.ev -log out2-ac.log
diff -b -q out2-ac.log test2.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum AC: FAILED"; else echo "Test $testnum AC: Success"; fi

testnum=$(($testnum+1))
../../bin/maxprod -m test1.bif -ev test1.ev -q test1.q -log out3-bn.log
diff -b -q out3-bn.log test3.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum BN: FAILED"; else echo "Test $testnum BN: Success"; fi

../../bin/maxprod -m test1.mn -ev test1.ev -q test1.q -log out3-mn.log
diff -b -q out3-mn.log test3.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN: FAILED"; else echo "Test $testnum MN: Success"; fi

../../bin/maxprod -m test1-f.mn -ev test1.ev -q test1.q -log out3-mnf.log
diff -b -q out3-mnf.log test3.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN-F: FAILED"; else echo "Test $testnum MN-F: Success"; fi

testnum=$(($testnum+1))
../../bin/maxprod -m test1-ev1.mn -log out4.log
diff -b -q out4.log test4.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

testnum=$(($testnum+1))
../../bin/maxprod -m test1-ev1.mn -ev test1.ev1 -log out5.log
diff -b -q out5.log test5.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

testnum=$(($testnum+1))
../../bin/maxprod -m test1-ev1.mn -ev test1.ev1 -q test1.q1 -log out6.log
diff -b -q out6.log test6.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi


# Testing MP on Alarm network

testnum=$(($testnum+1))
../../bin/maxprod -m alarm.bif -log out7-bn.log
diff -b -q out7-bn.log test7.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum BN: FAILED"; else echo "Test $testnum BN: Success"; fi

../../bin/maxprod -m alarm.mn -log out7-mn.log
diff -b -q out7-mn.log test7.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN: FAILED"; else echo "Test $testnum MN: Success"; fi

../../bin/maxprod -m alarm-f.mn -log out7-mnf.log
diff -b -q out7-mnf.log test7.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN-F: FAILED"; else echo "Test $testnum MN-F: Success"; fi

../../bin/acquery -mpe -c alarm.ac -log out7-ac.log
diff -b -q out7-ac.log test7.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum AC: FAILED"; else echo "Test $testnum AC: Success"; fi

testnum=$(($testnum+1))
../../bin/maxprod -m alarm.bif -ev alarm50.ev -log out8-bn.log
diff -b -q out8-bn.log test8-bn.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum BN: FAILED"; else echo "Test $testnum BN: Success"; fi

../../bin/maxprod -m alarm.mn -ev alarm50.ev -log out8-mn.log
diff -b -q out8-mn.log test8-mn.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN: FAILED"; else echo "Test $testnum MN: Success"; fi

../../bin/maxprod -m alarm-f.mn -ev alarm50.ev -log out8-mnf.log
diff -b -q out8-mnf.log test8-mnf.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN-F: FAILED"; else echo "Test $testnum MN-F: Success"; fi

../../bin/acquery -mpe -c alarm.ac -ev alarm50.ev -log out8-ac.log
diff -b -q out8-ac.log test8-ac.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum AC: FAILED"; else echo "Test $testnum AC: Success"; fi

testnum=$(($testnum+1))
../../bin/maxprod -m alarm.bif -ev alarm50.ev -q alarm.data -log out9-bn.log
diff -b -q out9-bn.log test9-bn.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum BN: FAILED"; else echo "Test $testnum BN: Success"; fi

../../bin/maxprod -m alarm.mn -ev alarm50.ev -q alarm.data -log out9-mn.log
diff -b -q out9-mn.log test9-mn.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN: FAILED"; else echo "Test $testnum MN: Success"; fi

../../bin/maxprod -m alarm-f.mn -ev alarm50.ev -q alarm.data -log out9-mnf.log
diff -b -q out9-mnf.log test9-mnf.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum MN-F: FAILED"; else echo "Test $testnum MN-F: Success"; fi

../../bin/maxprod -m alarm.ac -ev alarm50.ev -q alarm.data -log out9-ac.log
diff -b -q out9-ac.log test9-ac.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum AC: FAILED"; else echo "Test $testnum AC: Success"; fi

# TODO: Testing maxproduct on learned MSWeb network with decision tree CPDs
